import sys

from amqplib import client_0_8 as amqp

def respond(msg):
    body = msg.body
    print 'echoing %s' % body
    response = amqp.Message(body)
    msg.channel.basic_publish(response, exchange=msg.delivery_info['exchange'], routing_key=body)
    msg.channel.basic_ack(delivery_tag=msg.delivery_tag)

def echo(host, user, password, vhost, cb, exchange, queue, key):
    conn = amqp.Connection(host=host, userid=user, password=password, virtual_host=vhost)
    chan = conn.channel()
    chan.exchange_declare(exchange=exchange, type='topic', durable=False)
    chan.queue_declare(queue=queue, durable=False, exclusive=False, auto_delete=True)
    chan.queue_bind(queue=queue, exchange=exchange, routing_key=key)
    chan.basic_consume(queue=queue, no_ack=False, callback=respond, consumer_tag=queue)
    try:
        while True:
            chan.wait()
    finally:
        try:
            chan.basic_cancel(queue)
        except Exception, e:
            print 'Fail to cancel: %s' % e

def main():
    echo('localhost', 'guest', 'temp1234', '/', respond, 'demo', "echo", 'request')

if "__main__" == __name__:
    sys.exit(main())
